﻿using Microsoft.EntityFrameworkCore;
using TeamSample.Entities;

namespace TeamSample.Data
{
    public class TeamSampleDbContext : DbContext
    {
        public DbSet<Team> Teams { get; set; }
        public DbSet<Mascot> Mascots { get; set; }
        public DbSet<Player> Players { get; set; }
        public DbSet<PlayerPosition> PlayerPositions { get; set; }
        public DbSet<Position> Positions { get; set; }

        public TeamSampleDbContext(DbContextOptions<TeamSampleDbContext> options) : base(options)
        { }

        
        protected override void OnModelCreating(ModelBuilder builder)
        {
            builder.Entity<Team>()
                .HasOne(t => t.Mascot)
                .WithOne(m => m.Team)
                .HasForeignKey<Mascot>(m => m.TeamId);

            builder.Entity<PlayerPosition>().HasKey(pp => new { pp.PlayerId, pp.PositionId });

        }
    }
}